function [ux, uy, energies] = update_flow(i0, i1w, ux, uy, lamb, nbiter)
    %update_flow: main function that updates the optical flow for each step
    % TODO: implement this function.
    error('Not implemented');
end


function [dx] = Dx(h, w)
    %Dx: 
    e = ones(w, 1);
    Dx_tilde = spdiags([e -e], -1:0, w, w);
    Dx_tilde(end, end) = 0;
    dx = kron(Dx_tilde', speye(h));
end


function [dy] = Dy(h, w)
    e = ones(h, 1);
    Dy_tilde = spdiags([-e e], 0:1, h, h);
    Dy_tilde(end, end) = 0;
    dy = kron(speye(w), Dy_tilde);
end

   
function [nab] = nabla(h, w)
    %nabla: build (sparse) nabla operator
    nab = cat(1, Dx(h, w),  Dy(h, w));
end


function [dI] = D(I, h, w)
%D: compute image gradient along x,y directions. return shape (h*w, 2)
    dI = cat(2, Dx(h, w) * I,  Dy(h, w) * I);
end

